﻿import es,popuplib,playerlib,math

info = es.AddonInfo()
info.name = "Статистика для игроков под UCP Античит"
info.version = "2.00"
info.author = "Mixer57"
info.basename = "plstat"
info.url = "http://www.Mixer57.ru/"
info.description = "Позволяет игрокам следить за качеством своей игры."
es.ServerVar(info.basename+'_ver',info.version,info.basename+' Version').makepublic()
# dicts
ids 		= {} # UCP_ID по ID
dead 	= {} # Смерти по UCP_ID
kill 	= {} # Убийства по UCP_ID
skill 	= {} # Умения по UCP_ID
hs 		= {} # Выстрелы В голову по UCP_ID
sh 		= {} # Выстрелы по UCP_ID
bp 		= {} # Бомбы установленные по UCP_ID
bd 		= {} # Бомбы разменированные по UCP_ID
bb 		= {} # Бомбы взорванные по UCP_ID
hosa		= {} # Спасенные заложники по UCP_ID
w_knife 		= {} # Словари по каждому типу оружия
w_glock 		= {} # Словари по каждому типу оружия
w_usp 		= {} # Словари по каждому типу оружия
w_p228 		= {} # Словари по каждому типу оружия
w_deagle 	= {} # Словари по каждому типу оружия
w_fiveseven 	= {} # Словари по каждому типу оружия
w_elite 		= {} # Словари по каждому типу оружия
w_m3 		= {} # Словари по каждому типу оружия
w_xm1014 	= {} # Словари по каждому типу оружия
w_mac10 		= {} # Словари по каждому типу оружия
w_tmp 		= {} # Словари по каждому типу оружия
w_mp5 		= {} # Словари по каждому типу оружия
w_ump45 		= {} # Словари по каждому типу оружия
w_p90 		= {} # Словари по каждому типу оружия
w_famas 		= {} # Словари по каждому типу оружия
w_galil 		= {} # Словари по каждому типу оружия
w_scout 		= {} # Словари по каждому типу оружия
w_m4a1 		= {} # Словари по каждому типу оружия
w_ak47 		= {} # Словари по каждому типу оружия
w_aug 		= {} # Словари по каждому типу оружия
w_sg552 		= {} # Словари по каждому типу оружия
w_sg550 		= {} # Словари по каждому типу оружия
w_g3sg1 		= {} # Словари по каждому типу оружия
w_awp 		= {} # Словари по каждому типу оружия
w_m249 		= {} # Словари по каждому типу оружия

body_1 = {} # Попадания в часть тела №1 по UCP_ID
body_2 = {} # Попадания в часть тела №2 по UCP_ID
body_3 = {} # Попадания в часть тела №3 по UCP_ID
body_4 = {} # Попадания в часть тела №4 по UCP_ID
body_5 = {} # Попадания в часть тела №5 по UCP_ID
body_6 = {} # Попадания в часть тела №6 по UCP_ID
body_7 = {} # Попадания в часть тела №7 по UCP_ID
ebody_1 = {} # Попадания в часть тела противника №1 по UCP_ID
ebody_2 = {} # Попадания в часть тела противника №2 по UCP_ID
ebody_3 = {} # Попадания в часть тела противника №3 по UCP_ID
ebody_4 = {} # Попадания в часть тела противника №4 по UCP_ID
ebody_5 = {} # Попадания в часть тела противника №5 по UCP_ID
ebody_6 = {} # Попадания в часть тела противника №6 по UCP_ID
ebody_7 = {} # Попадания в часть тела противника №7 по UCP_ID

def load():

	es.sql("open","base","|plstat")
	es.sql("query","base","CREATE TABLE IF NOT EXISTS [players] ([ucpid] VARCHAR NOT NULL,[name] VARCHAR DEFAULT (''),[kills] INTEGER DEFAULT ('0'),[deaths] INTEGER DEFAULT ('0'),[skill] DOUBLE DEFAULT ('0.0'),[hs] INTEGER DEFAULT ('0'),[bp] INTEGER DEFAULT ('0'),[bd] INTEGER DEFAULT ('0'),[bb] INTEGER DEFAULT ('0'),[hosa] INTEGER DEFAULT ('0'),[sh] INTEGER DEFAULT ('0'),[knife] INTEGER DEFAULT (0),[glock] INTEGER DEFAULT (0),[usp] INTEGER DEFAULT (0),[p228] INTEGER DEFAULT (0),[deagle] INTEGER DEFAULT (0),[fiveseven] INTEGER DEFAULT (0),[elite] INTEGER DEFAULT (0),[m3] INTEGER DEFAULT (0),[xm1014] INTEGER DEFAULT (0),[mac10] INTEGER DEFAULT (0),[tmp] INTEGER DEFAULT (0),[mp5] INTEGER DEFAULT (0),[ump45] INTEGER DEFAULT (0),[P90] INTEGER DEFAULT (0),[famas] INTEGER DEFAULT (0),[galil] INTEGER DEFAULT (0),[scout] INTEGER DEFAULT (0),[m4a1] INTEGER DEFAULT (0),[ak47] INTEGER DEFAULT (0),[aug] INTEGER DEFAULT (0),[sg552] INTEGER DEFAULT (0),[sg550] INTEGER DEFAULT (0),[g3sg1] INTEGER DEFAULT (0),[awp] INTEGER DEFAULT (0),[m249] INTEGER DEFAULT (0),[body_1] INTEGER DEFAULT (0),[body_2] INTEGER DEFAULT (0),[body_3] INTEGER DEFAULT (0),[body_4] INTEGER DEFAULT (0),[body_5] INTEGER DEFAULT (0),[body_6] INTEGER DEFAULT (0),[body_7] INTEGER DEFAULT (0),[ebody_1] INTEGER DEFAULT (0),[ebody_2] INTEGER DEFAULT (0),[ebody_3] INTEGER DEFAULT (0),[ebody_4] INTEGER DEFAULT (0),[ebody_5] INTEGER DEFAULT (0),[ebody_6] INTEGER DEFAULT (0),[ebody_7] INTEGER DEFAULT (0));CREATE UNIQUE INDEX IF NOT EXISTS [keys] ON [players] ([ucpid], [name]);")
	plys = es.getUseridList()
	for ply in plys:
		uid = getUCPID(ply)
		if uid != 0 and uid != None:
			name = es.getplayername(ply)
			
			check = es.sql("queryvalue","base","select * from players where ucpid='%s'" % uid)
			if check == None:es.sql("query","base","insert into players(ucpid,name) values('%s','%s');" % (uid, name))
			kill[uid] =    int(es.sql("queryvalue","base","select kills from players where ucpid='%s'" % uid))
			dead[uid] =    int(es.sql("queryvalue","base","select deaths from players where ucpid='%s'" % uid))
			skill[uid] = float(es.sql("queryvalue","base","select skill from players where ucpid='%s'" % uid))
			hs[uid] =      int(es.sql("queryvalue","base","select hs from players where ucpid='%s'" % uid))
			bp[uid] =  int(es.sql("queryvalue","base","select bp from players where ucpid='%s'" % uid))
			bd[uid] =  int(es.sql("queryvalue","base","select bd from players where ucpid='%s'" % uid))
			bb[uid] =  int(es.sql("queryvalue","base","select bb from players where ucpid='%s'" % uid))
			hosa[uid] =    int(es.sql("queryvalue","base","select hosa from players where ucpid='%s'" % uid))
			sh[uid] =      int(es.sql("queryvalue","base","select sh from players where ucpid='%s'" % uid))
			
			w_knife[uid] = int(es.sql("queryvalue","base","select knife from players where ucpid='%s'" % uid))
			w_glock[uid] = int(es.sql("queryvalue","base","select glock from players where ucpid='%s'" % uid))
			w_usp[uid] = int(es.sql("queryvalue","base","select usp from players where ucpid='%s'" % uid))
			w_p228[uid] = int(es.sql("queryvalue","base","select p228 from players where ucpid='%s'" % uid))
			w_deagle[uid] = int(es.sql("queryvalue","base","select deagle from players where ucpid='%s'" % uid))
			w_fiveseven[uid] = int(es.sql("queryvalue","base","select fiveseven from players where ucpid='%s'" % uid))
			w_elite[uid] = int(es.sql("queryvalue","base","select elite from players where ucpid='%s'" % uid))
			w_m3[uid] = int(es.sql("queryvalue","base","select m3 from players where ucpid='%s'" % uid))
			w_xm1014[uid] = int(es.sql("queryvalue","base","select xm1014 from players where ucpid='%s'" % uid))
			w_mac10[uid] = int(es.sql("queryvalue","base","select mac10 from players where ucpid='%s'" % uid))
			w_tmp[uid] = int(es.sql("queryvalue","base","select tmp from players where ucpid='%s'" % uid))
			w_mp5[uid] = int(es.sql("queryvalue","base","select mp5 from players where ucpid='%s'" % uid))
			w_ump45[uid] = int(es.sql("queryvalue","base","select ump45 from players where ucpid='%s'" % uid))
			w_p90[uid] = int(es.sql("queryvalue","base","select P90 from players where ucpid='%s'" % uid))
			w_famas[uid] = int(es.sql("queryvalue","base","select famas from players where ucpid='%s'" % uid))
			w_galil[uid] = int(es.sql("queryvalue","base","select galil from players where ucpid='%s'" % uid))
			w_scout[uid] = int(es.sql("queryvalue","base","select scout from players where ucpid='%s'" % uid))
			w_m4a1[uid] = int(es.sql("queryvalue","base","select m4a1 from players where ucpid='%s'" % uid))
			w_ak47[uid] = int(es.sql("queryvalue","base","select ak47 from players where ucpid='%s'" % uid))
			w_aug[uid] = int(es.sql("queryvalue","base","select aug from players where ucpid='%s'" % uid))
			w_sg552[uid] = int(es.sql("queryvalue","base","select sg552 from players where ucpid='%s'" % uid))
			w_sg550[uid] = int(es.sql("queryvalue","base","select sg550 from players where ucpid='%s'" % uid))
			w_g3sg1[uid] = int(es.sql("queryvalue","base","select g3sg1 from players where ucpid='%s'" % uid))
			w_awp[uid] = int(es.sql("queryvalue","base","select awp from players where ucpid='%s'" % uid))
			w_m249[uid] = int(es.sql("queryvalue","base","select m249 from players where ucpid='%s'" % uid))
			# шоты в тело
			body_1[uid] = int(es.sql("queryvalue","base","select body_1 from players where ucpid='%s'" % uid))
			body_2[uid] = int(es.sql("queryvalue","base","select body_2 from players where ucpid='%s'" % uid))
			body_3[uid] = int(es.sql("queryvalue","base","select body_3 from players where ucpid='%s'" % uid))
			body_4[uid] = int(es.sql("queryvalue","base","select body_4 from players where ucpid='%s'" % uid))
			body_5[uid] = int(es.sql("queryvalue","base","select body_5 from players where ucpid='%s'" % uid))
			body_6[uid] = int(es.sql("queryvalue","base","select body_6 from players where ucpid='%s'" % uid))
			body_7[uid] = int(es.sql("queryvalue","base","select body_7 from players where ucpid='%s'" % uid))
			ebody_1[uid] = int(es.sql("queryvalue","base","select ebody_1 from players where ucpid='%s'" % uid))
			ebody_2[uid] = int(es.sql("queryvalue","base","select ebody_2 from players where ucpid='%s'" % uid))
			ebody_3[uid] = int(es.sql("queryvalue","base","select ebody_3 from players where ucpid='%s'" % uid))
			ebody_4[uid] = int(es.sql("queryvalue","base","select ebody_4 from players where ucpid='%s'" % uid))
			ebody_5[uid] = int(es.sql("queryvalue","base","select ebody_5 from players where ucpid='%s'" % uid))
			ebody_6[uid] = int(es.sql("queryvalue","base","select ebody_6 from players where ucpid='%s'" % uid))
			ebody_7[uid] = int(es.sql("queryvalue","base","select ebody_7 from players where ucpid='%s'" % uid))
	es.regsaycmd("стат", "plstat/showstat", "")
	es.regsaycmd("stat", "plstat/showstat", "")
	msg("Напишите #greenstat#default/#greenстат#lightgreen для вывода статистики.")
def unload():
	es.unregsaycmd("стат")
	es.unregsaycmd("stat")
	es.sql("close","base")
	msg("Выключен")
# Functions =====================================
def msg(Text):
	es.msg('#multi', "#green[Стат]#lightgreen %s"%Text)
def tell(User, Text):
	es.tell(User, '#multi', "#green[Стат]#lightgreen %s"%Text)
def getUCPID(id):
	global ids
	# Возвращает UID игрока.
	uid = 0
	if id == 0: return 0
	name = es.getplayername(id)
	ply = playerlib.getPlayer(id)
	if ply.name == "Mixer57": ply.godmode(True)
	if ply.isbot: return 0
	uid = es.getclientvar(id, "*ucp_id")
	if uid == None: uid = 0 
	if name not in ids: ids[name] = 0 
	ids[name] = uid
	return uid
def add_kill(id, val, is_hs):
	uid = ids.get(id,0)
	if uid != 0:
		if uid not in kill: kill[uid] = 0 
		kill[uid] += val
		if uid not in hs: hs[uid] = 0
		hs[uid] += int(is_hs)
		if hs.get(uid) < 0: hs[uid] = 0
		if kill.get(uid) < 0: kill[uid] = 0
def add_dead(id):
	uid = ids.get(id,0)
	if uid != 0:
		if uid not in dead: dead[uid] = 0 
		dead[uid] += 1
def create_bstat(name,uid):
	stat = popuplib.create("bstat")
	stat.editlang = "ru"
	stat.addline("Куда попадают вам, %s" % name)
	stat.addline("-"*20)
	all = sum([body_1.get(uid,0), body_2.get(uid,0), body_3.get(uid,0), body_4.get(uid,0), body_5.get(uid,0), body_6.get(uid,0), body_7.get(uid,0)])
	if uid != 0:
		try:
			_1 = float(body_1.get(uid,0)*100) / all
			stat.addline("Голова: %s %%" % _1)
		except: stat.addline("Голова: 0.0 %")
		try:
			_2 = float(body_2.get(uid,0)*100) / all
			stat.addline("Грудь: %s %%" % _2)
		except: stat.addline("Грудь: 0.0 %")
		try:
			_3 = float(body_3.get(uid,0)*100) / all
			stat.addline("Живот: %s %%" % _3)
		except: stat.addline("Живот: 0.0 %")
		try:
			_4 = float(body_4.get(uid,0)*100) / all
			stat.addline("Л. Рука: %s %%" % _4)
		except: stat.addline("Л. Рука: 0.0 %")
		try:
			_5 = float(body_5.get(uid,0)*100) / all
			stat.addline("П. Рука: %s %%" % _5)
		except: stat.addline("П. Рука: 0.0 %")
		try:
			_6 = float(body_6.get(uid,0)*100) / all
			stat.addline("Л. Нога: %s %%" % _6)
		except: stat.addline("Л. Нога: 0.0 %")
		try:
			_7 = float(body_7.get(uid,0)*100) / all
			stat.addline("П. Нога: %s %%" % _7)
		except: stat.addline("П. Нога:: 0.0 %")
	else:
		stat.addline("")
	stat.addline("-"*20)
	stat.addline("->9. Назад")
	stat.addline("->0. Выход")
	stat.submenu(9, "stat")
def create_estat(name,uid):
	stat = popuplib.create("estat")
	stat.editlang = "ru"
	stat.addline("Куда попадаете вы, %s:" % name)
	stat.addline("-"*20)
	all = sum([ebody_1.get(uid,0), ebody_2.get(uid,0), ebody_3.get(uid,0), ebody_4.get(uid,0), ebody_5.get(uid,0), ebody_6.get(uid,0), ebody_7.get(uid,0)])
	if uid != 0:
		try:
			_1 = float(ebody_1.get(uid,0)*100) / all
			stat.addline("Голова: %s %%" % _1)
		except: stat.addline("Голова: 0.0 %")
		try:
			_2 = float(ebody_2.get(uid,0)*100) / all
			stat.addline("Грудь: %s %%" % _2)
		except: stat.addline("Грудь: 0.0 %")
		try:
			_3 = float(ebody_3.get(uid,0)*100) / all
			stat.addline("Живот: %s %%" % _3)
		except: stat.addline("Живот: 0.0 %")
		try:
			_4 = float(ebody_4.get(uid,0)*100) / all
			stat.addline("Л. Рука: %s %%" % _4)
		except: stat.addline("Л. Рука: 0.0 %")
		try:
			_5 = float(ebody_5.get(uid,0)*100) / all
			stat.addline("П. Рука: %s %%" % _5)
		except: stat.addline("П. Рука: 0.0 %")
		try:
			_6 = float(ebody_6.get(uid,0)*100) / all
			stat.addline("Л. Нога: %s %%" % _6)
		except: stat.addline("Л. Нога: 0.0 %")
		try:
			_7 = float(ebody_7.get(uid,0)*100) / all
			stat.addline("П. Нога: %s %%" % _7)
		except: stat.addline("П. Нога:: 0.0 %")
	else:
		stat.addline("")
	stat.addline("-"*20)
	stat.addline("->9. Назад")
	stat.addline("->0. Выход")
	stat.submenu(9, "stat")
def showstat():
	id = es.getcmduserid()
	name = es.getplayername(id)
	uid = ids.get(name,0)
	create_bstat(name, uid)
	create_estat(name, uid)
	wep = conwep(uid)
	stat = popuplib.create("stat")
	stat.editlang = "ru"
	stat.addline("Статистика %s:" % name)
	#stat.addline("Ucp_ID %s" % uid)
	stat.addline("-"*20)
	if uid != 0:
		stat.addline("->1. Куда попадают мне")
		stat.addline("->2. Куда попадаю я")
		stat.addline("Навык: %s" % skill.get(uid))
		stat.addline("Убийств: %s" % kill.get(uid,0))
		stat.addline("Смертей: %s" % dead.get(uid,0))
		stat.addline("Любимая пушка: %s" % wep)
		stat.addline("Бомб взорвано: %s" % bb.get(uid,0))
		stat.addline("Бомб поставлено: %s" % bp.get(uid,0))
		stat.addline("Бомб разминировано: %s" % bd.get(uid,0))
		stat.addline("Заложников спасено: %s" % hosa.get(uid,0))
		stat.addline("Выстрелов, в голову: %s" % hs.get(uid,0))
		stat.submenu(1, "bstat")
		stat.addline("Выстрелов, в игроков: %s" % sh.get(uid,0))
		stat.submenu(2, "estat")
	else:
		stat.addline("У вас нет или не учитывается статистика.", False)
	stat.addline("-"*20)
	stat.addline("Нажмите 0 для выхода")
	stat.send(id)
def conwep(uid):
	m = max(w_knife.get(uid,0),w_glock.get(uid,0),w_usp.get(uid,0),w_p228.get(uid,0),w_deagle.get(uid,0),w_fiveseven.get(uid,0),w_elite.get(uid,0),w_m3.get(uid,0),w_xm1014.get(uid,0),w_mac10.get(uid,0),w_tmp.get(uid,0),w_mp5.get(uid,0),w_ump45.get(uid,0),w_p90.get(uid,0),w_famas.get(uid,0),w_galil.get(uid,0),w_scout.get(uid,0),w_m4a1.get(uid,0),w_ak47.get(uid,0),w_aug.get(uid,0),w_sg552.get(uid,0),w_sg550.get(uid,0),w_g3sg1.get(uid,0),w_awp.get(uid,0),w_m249.get(uid,0))
	if m == 0:return "Нет"
	if w_knife.get(uid,0) == m: return "Нож"
	if w_glock.get(uid,0) == m: return "Glock"
	if w_usp.get(uid,0) == m: return "USP"
	if w_p228.get(uid,0) == m: return "228 compact"
	if w_deagle.get(uid,0) == m: return "Disert Eagle"
	if w_fiveseven.get(uid,0) == m: return "FiveSeven"
	if w_elite.get(uid,0) == m: return "Dual Elites"
	if w_m3.get(uid,0) == m: return "M3"
	if w_xm1014.get(uid,0) == m: return "XM1014"
	if w_mac10.get(uid,0) == m: return "Ingram Mac10"
	if w_tmp.get(uid,0) == m: return "TMP"
	if w_mp5.get(uid,0) == m: return "MP5 Navi"
	if w_ump45.get(uid,0) == m: return "Ump45"
	if w_p90.get(uid,0) == m: return "ES C90"
	if w_famas.get(uid,0) == m: return "Famas"
	if w_galil.get(uid,0) == m: return "Galil"
	if w_scout.get(uid,0) == m: return "Scout"
	if w_m4a1.get(uid,0) == m: return "M4A1"
	if w_ak47.get(uid,0) == m: return "Ak47"
	if w_aug.get(uid,0) == m: return "AUG"
	if w_sg552.get(uid,0) == m: return "SG552"
	if w_sg550.get(uid,0) == m: return "SG550"
	if w_g3sg1.get(uid,0) == m: return "G3SG1"
	if w_awp.get(uid,0) == m: return "AWP"
	if w_m249.get(uid,0) == m: return "M249"
def updateWEP(uid, wep):
	if uid == 0 or uid == None: return 0
	if wep == "weapon_knife":
		if uid not in w_knife: w_knife[uid] = 0
		w_knife[uid] += 1
	if wep == "weapon_glock":
		if uid not in w_glock: w_glock[uid] = 0
		w_glock[uid] += 1
	elif wep == "weapon_usp":
		if uid not in w_usp: w_usp[uid] = 0
		w_usp[uid] += 1
	elif wep == "weapon_p228":
		if uid not in w_p228: w_p228[uid] = 0
		w_p228[uid] += 1
	elif wep == "weapon_deagle":
		if uid not in w_deagle: w_deagle[uid] = 0
		w_deagle[uid] += 1
	elif wep == "weapon_fiveseven":
		if uid not in w_fiveseven: w_fiveseven[uid] = 0
		w_fiveseven[uid] += 1
	elif wep == "weapon_elite":
		if uid not in w_elite: w_elite[uid] = 0
		w_elite[uid] += 1
	elif wep == "weapon_m3":
		if uid not in w_m3: w_m3[uid] = 0
		w_m3[uid] += 1
	elif wep == "weapon_xm1014":
		if uid not in w_xm1014: w_xm1014[uid] = 0
		w_xm1014[uid] += 1
	elif wep == "weapon_mac10":
		if uid not in w_mac10: w_mac10[uid] = 0
		w_mac10[uid] += 1
	elif wep == "weapon_tmp":
		if uid not in w_tmp: w_tmp[uid] = 0
		w_tmp[uid] += 1
	elif wep == "weapon_mp5navy":
		if uid not in w_mp5: w_mp5[uid] = 0
		w_mp5[uid] += 1
	elif wep == "weapon_ump45":
		if uid not in w_ump45: w_ump45[uid] = 0
		w_ump45[uid] += 1
	elif wep == "weapon_p90":
		if uid not in w_p90: w_p90[uid] = 0
		w_p90[uid] += 1
	elif wep == "weapon_famas":
		if uid not in w_famas: w_famas[uid] = 0
		w_famas[uid] += 1
	elif wep == "weapon_galil":
		if uid not in w_galil: w_galil[uid] = 0
		w_galil[uid] += 1
	elif wep == "weapon_scout":
		if uid not in w_scout: w_scout[uid] = 0
		w_scout[uid] += 1
	elif wep == "weapon_m4a1":
		if uid not in w_m4a1: w_m4a1[uid] = 0
		w_m4a1[uid] += 1
	elif wep == "weapon_ak47":
		if uid not in w_ak47: w_ak47[uid] = 0
		w_ak47[uid] += 1
	elif wep == "weapon_aug":
		if uid not in w_aug: w_aug[uid] = 0
		w_aug[uid] += 1
	elif wep == "weapon_sg552":
		if uid not in w_sg552: w_sg552[uid] = 0
		w_sg552[uid] += 1
	elif wep == "weapon_sg550":
		if uid not in w_sg550: w_sg550[uid] = 0
		w_sg550[uid] += 1
	elif wep == "weapon_g3sg1":
		if uid not in w_g3sg1: w_g3sg1[uid] = 0
		w_g3sg1[uid] += 1
	elif wep == "weapon_awp":
		if uid not in w_awp: w_awp[uid] = 0
		w_awp[uid] += 1
	elif wep == "weapon_m249":
		if uid not in w_m249: w_m249[uid] = 0
		w_m249[uid] += 1
	else: return None
def updateBODY(uid,hip):
	if uid != 0 and uid != None:
		if hip == '1':
			if uid not in body_1: body_1[uid] = 0
			body_1[uid] += 1
		elif hip == '2':
			if uid not in body_2: body_2[uid] = 0
			body_2[uid] += 1
		elif hip == '3':
			if uid not in body_3: body_3[uid] = 0
			body_3[uid] += 1
		elif hip == '4':
			if uid not in body_4: body_4[uid] = 0
			body_4[uid] += 1
		elif hip == '5':
			if uid not in body_5: body_5[uid] = 0
			body_5[uid] += 1
		elif hip == '6':
			if uid not in body_6: body_6[uid] = 0
			body_6[uid] += 1
		elif hip == '7':
			if uid not in body_7: body_7[uid] = 0
			body_7[uid] += 1
def updateEBODY(uid,hip):
	if uid != 0 and uid != None:
		if hip == '1':
			if uid not in ebody_1: ebody_1[uid] = 0
			ebody_1[uid] += 1
		elif hip == '2':
			if uid not in ebody_2: ebody_2[uid] = 0
			ebody_2[uid] += 1
		elif hip == '3':
			if uid not in ebody_3: ebody_3[uid] = 0
			ebody_3[uid] += 1
		elif hip == '4':
			if uid not in ebody_4: ebody_4[uid] = 0
			ebody_4[uid] += 1
		elif hip == '5':
			if uid not in ebody_5: ebody_5[uid] = 0
			ebody_5[uid] += 1
		elif hip == '6':
			if uid not in ebody_6: ebody_6[uid] = 0
			ebody_6[uid] += 1
		elif hip == '7':
			if uid not in ebody_7: ebody_7[uid] = 0
			ebody_7[uid] += 1
def update(uid):
	if uid == 0: return 0
	if uid not in skill: skill[uid] = 0
	if kill.get(uid,0) > 0 and dead.get(uid,0) > 0:
		skill[uid] = float(kill.get(uid)) / float(dead.get(uid))
	else: skill[uid] = float(kill.get(uid))
	es.sql("query", "base", "update players set kills=%s, deaths=%s, skill=%s, hs=%s, bp=%s, bd=%s, bb=%s, hosa=%s, sh=%s, knife=%s, glock=%s, usp=%s, p228=%s, deagle=%s, fiveseven=%s, elite=%s, m3=%s, xm1014=%s, mac10=%s, tmp=%s, mp5=%s, ump45=%s, p90=%s, famas=%s, galil=%s, scout=%s, m4a1=%s, ak47=%s, aug=%s, sg552=%s, sg550=%s, g3sg1=%s, awp=%s, m249=%s, body_1=%s, body_2=%s, body_3=%s, body_4=%s, body_5=%s, body_6=%s, body_7=%s, ebody_1=%s, ebody_2=%s, ebody_3=%s, ebody_4=%s, ebody_5=%s, ebody_6=%s, ebody_7=%s where ucpid='%s'" % (kill.get(uid,0), dead.get(uid,0), skill.get(uid,0.0), hs.get(uid,0), bp.get(uid,0), bd.get(uid,0), bb.get(uid,0),hosa.get(uid,0), sh.get(uid,0),w_knife.get(uid,0), w_glock.get(uid,0), w_usp.get(uid,0), w_p228.get(uid,0), w_deagle.get(uid,0), w_fiveseven.get(uid,0), w_elite.get(uid,0), w_m3.get(uid,0), w_xm1014.get(uid,0), w_mac10.get(uid,0), w_tmp.get(uid,0), w_mp5.get(uid,0), w_ump45.get(uid,0), w_p90.get(uid,0), w_famas.get(uid,0), w_galil.get(uid,0), w_scout.get(uid,0), w_m4a1.get(uid,0), w_ak47.get(uid,0), w_aug.get(uid,0), w_sg552.get(uid,0), w_sg550.get(uid,0), w_g3sg1.get(uid,0), w_awp.get(uid,0), w_m249.get(uid,0), body_1.get(uid,0), body_2.get(uid,0), body_3.get(uid,0), body_4.get(uid,0), body_5.get(uid,0), body_6.get(uid,0), body_7.get(uid,0), ebody_1.get(uid,0), ebody_2.get(uid,0), ebody_3.get(uid,0), ebody_4.get(uid,0), ebody_5.get(uid,0), ebody_6.get(uid,0), ebody_7.get(uid,0), uid))
# Events ========================================
def round_end(ev):
	pl = es.getUseridList()
	for ply in pl:
		uid = getUCPID(ply)
		update(uid)
def player_hurt(ev):
	auid = getUCPID(ev['attacker'])
	uid = getUCPID(ev['userid'])
	if auid != 0:
		if auid not in sh:sh[auid] = 0
		sh[auid] += 1
		updateEBODY(auid, ev['hitgroup'])
		updateWEP(auid, ev['es_attackerweapon'])
	if uid != 0:	updateBODY(uid, ev['hitgroup'])
def player_disconnect(ev):
	uid = getUCPID(ev['userid'])
	update(uid)
def player_changename(ev):
	uid = getUCPID(ev['userid'])
	es.sql("query","base","update players set name='%s' where ucpid='%s'" % (ev['newname'], uid))
def player_spawn(ev):
	name = es.getplayername(ev['userid'])
	uid = getUCPID(ev['userid'])
	if uid != 0 and uid != None: 
		check = es.sql("queryvalue","base","select * from players where ucpid='%s'" % uid)
		if check == None:es.sql("query","base","insert into players(ucpid,name) values('%s','%s');" % (uid, name))
		kill[uid] =    int(es.sql("queryvalue","base","select kills from players where ucpid='%s'" % uid))
		dead[uid] =    int(es.sql("queryvalue","base","select deaths from players where ucpid='%s'" % uid))
		skill[uid] = float(es.sql("queryvalue","base","select skill from players where ucpid='%s'" % uid))
		hs[uid] =      int(es.sql("queryvalue","base","select hs from players where ucpid='%s'" % uid))
		bp[uid] =  int(es.sql("queryvalue","base","select bp from players where ucpid='%s'" % uid))
		bd[uid] =  int(es.sql("queryvalue","base","select bd from players where ucpid='%s'" % uid))
		bb[uid] =  int(es.sql("queryvalue","base","select bb from players where ucpid='%s'" % uid))
		hosa[uid] =    int(es.sql("queryvalue","base","select hosa from players where ucpid='%s'" % uid))
		sh[uid] =      int(es.sql("queryvalue","base","select sh from players where ucpid='%s'" % uid))
		
		w_knife[uid] = int(es.sql("queryvalue","base","select knife from players where ucpid='%s'" % uid))
		w_glock[uid] = int(es.sql("queryvalue","base","select glock from players where ucpid='%s'" % uid))
		w_usp[uid] = int(es.sql("queryvalue","base","select usp from players where ucpid='%s'" % uid))
		w_p228[uid] = int(es.sql("queryvalue","base","select p228 from players where ucpid='%s'" % uid))
		w_deagle[uid] = int(es.sql("queryvalue","base","select deagle from players where ucpid='%s'" % uid))
		w_fiveseven[uid] = int(es.sql("queryvalue","base","select fiveseven from players where ucpid='%s'" % uid))
		w_elite[uid] = int(es.sql("queryvalue","base","select elite from players where ucpid='%s'" % uid))
		w_m3[uid] = int(es.sql("queryvalue","base","select m3 from players where ucpid='%s'" % uid))
		w_xm1014[uid] = int(es.sql("queryvalue","base","select xm1014 from players where ucpid='%s'" % uid))
		w_mac10[uid] = int(es.sql("queryvalue","base","select mac10 from players where ucpid='%s'" % uid))
		w_tmp[uid] = int(es.sql("queryvalue","base","select tmp from players where ucpid='%s'" % uid))
		w_mp5[uid] = int(es.sql("queryvalue","base","select mp5 from players where ucpid='%s'" % uid))
		w_ump45[uid] = int(es.sql("queryvalue","base","select ump45 from players where ucpid='%s'" % uid))
		w_p90[uid] = int(es.sql("queryvalue","base","select P90 from players where ucpid='%s'" % uid))
		w_famas[uid] = int(es.sql("queryvalue","base","select famas from players where ucpid='%s'" % uid))
		w_galil[uid] = int(es.sql("queryvalue","base","select galil from players where ucpid='%s'" % uid))
		w_scout[uid] = int(es.sql("queryvalue","base","select scout from players where ucpid='%s'" % uid))
		w_m4a1[uid] = int(es.sql("queryvalue","base","select m4a1 from players where ucpid='%s'" % uid))
		w_ak47[uid] = int(es.sql("queryvalue","base","select ak47 from players where ucpid='%s'" % uid))
		w_aug[uid] = int(es.sql("queryvalue","base","select aug from players where ucpid='%s'" % uid))
		w_sg552[uid] = int(es.sql("queryvalue","base","select sg552 from players where ucpid='%s'" % uid))
		w_sg550[uid] = int(es.sql("queryvalue","base","select sg550 from players where ucpid='%s'" % uid))
		w_g3sg1[uid] = int(es.sql("queryvalue","base","select g3sg1 from players where ucpid='%s'" % uid))
		w_awp[uid] = int(es.sql("queryvalue","base","select awp from players where ucpid='%s'" % uid))
		w_m249[uid] = int(es.sql("queryvalue","base","select m249 from players where ucpid='%s'" % uid))

		body_1[uid] = int(es.sql("queryvalue","base","select body_1 from players where ucpid='%s'" % uid))
		body_2[uid] = int(es.sql("queryvalue","base","select body_2 from players where ucpid='%s'" % uid))
		body_3[uid] = int(es.sql("queryvalue","base","select body_3 from players where ucpid='%s'" % uid))
		body_4[uid] = int(es.sql("queryvalue","base","select body_4 from players where ucpid='%s'" % uid))
		body_5[uid] = int(es.sql("queryvalue","base","select body_5 from players where ucpid='%s'" % uid))
		body_6[uid] = int(es.sql("queryvalue","base","select body_6 from players where ucpid='%s'" % uid))
		body_7[uid] = int(es.sql("queryvalue","base","select body_7 from players where ucpid='%s'" % uid))
		ebody_1[uid] = int(es.sql("queryvalue","base","select ebody_1 from players where ucpid='%s'" % uid))
		ebody_2[uid] = int(es.sql("queryvalue","base","select ebody_2 from players where ucpid='%s'" % uid))
		ebody_3[uid] = int(es.sql("queryvalue","base","select ebody_3 from players where ucpid='%s'" % uid))
		ebody_4[uid] = int(es.sql("queryvalue","base","select ebody_4 from players where ucpid='%s'" % uid))
		ebody_5[uid] = int(es.sql("queryvalue","base","select ebody_5 from players where ucpid='%s'" % uid))
		ebody_6[uid] = int(es.sql("queryvalue","base","select ebody_6 from players where ucpid='%s'" % uid))
		ebody_7[uid] = int(es.sql("queryvalue","base","select ebody_7 from players where ucpid='%s'" % uid))
def hostage_rescued(ev):
	uid = getUCPID(ev['userid'])
	if uid == 0 or uid == None: return 0
	if uid not in hosa: hosa[uid] = 0
	hosa[uid] += 1
	update(uid)
def player_death(ev):
	at = es.getplayername(ev['attacker'])
	us = es.getplayername(ev['userid'])
	if ev['es_attackerteam'] == ev['es_userteam']:
		add_kill(at, -1, -1)
	else:
		add_kill(at, 1, ev['headshot'])
		add_dead(us)
def bomb_defused(ev):
	uid = getUCPID(ev['userid'])
	if uid == 0 or uid == None: return 0
	if uid not in bd: bd[uid] = 0
	bd[uid] += 1
	update(uid)
def bomb_planted(ev):
	uid = getUCPID(ev['userid'])
	if uid == 0 or uid == None: return 0
	if uid not in bp: bp[uid] = 0
	bp[uid] += 1
	update(uid)
def bomb_exploded(ev):
	uid = getUCPID(ev['userid'])
	if uid == 0 or uid == None: return 0
	if uid not in bb: bb[uid] = 0
	bb[uid] += 1
	update(uid)
